import type { GetServerSideProps } from "next";
import Link from "next/link";
import { AllegatoIframe } from "~/components/allegato-iframe";
import { DocNotFoundPage } from "~/components/doc_not_found";
import { AreaRiservataLayout } from "~/components/Layout";
import { LoadingPage } from "~/components/loading";
import { Status500 } from "~/components/status-page";
import { getStorageUrl } from "~/lib/storage_utils";
import type { NextPageWithLayout } from "~/pages/_app";
import { useTranslation } from "~/providers/I18nProvider";
import type { AnnunciId } from "~/schemas/public/Annunci";
import type { ServizioServizioId } from "~/schemas/public/Servizio";
import { TrpcAuthedFetchingIstance } from "~/server/utils/ssgHelper";
import { zAnnuncioId, zServizioId } from "~/server/utils/zod_types";
import { api } from "~/utils/api";

type ContrattoViewerProps = {
	servizioId: ServizioServizioId;
	annuncioId: AnnunciId;
};

const ContrattoViewer: NextPageWithLayout<ContrattoViewerProps> = ({
	servizioId,
	annuncioId,
}: ContrattoViewerProps) => {
	const { data, isLoading } = api.servizio.getServizioAnnuncio.useQuery({
		annuncioId,
		servizioId,
	});
	const { t } = useTranslation();
	if (isLoading) return <LoadingPage />;
	if (!data) return <Status500 />;
	if (!data.doc_registrazione_ref) return <DocNotFoundPage />;
	return (
		<div className="mx-2 flex flex-1 overflow-auto">
			<div className="mx-auto flex grow sm:grow-0">
				<div className="flex flex-col items-center space-y-4 py-4">
					<h1 className="font-bold text-xl">
						{t.servizio.contratto_view.ricevuta}
					</h1>
					<p className="text-center">
						{t.servizio.contratto_view.ricevuta_cta}
					</p>
					<FileSection storageId={data.doc_registrazione_ref} />
				</div>
			</div>
		</div>
	);
};

const FileSection = ({ storageId }: { storageId: string }) => {
	const { data: fileInfos, isLoading } = api.storage.getFileInfos.useQuery({
		storageId,
	});
	const { t } = useTranslation();
	if (isLoading) return <LoadingPage />;
	if (!fileInfos) return <p>{t.file_section.error}</p>;
	return (
		<>
			<AllegatoIframe allegato={fileInfos} className="h-full max-h-[70vh]" />

			<Link
				className="underline underline-offset-1 after:content-['_↗']"
				href={getStorageUrl({
					storageId: fileInfos.id,
					params: { mode: "download" },
				})}
			>
				{t.file_section.download}
			</Link>
		</>
	);
};

ContrattoViewer.getLayout = function getLayout(page) {
	return <AreaRiservataLayout noSidebar>{page}</AreaRiservataLayout>;
};

export default ContrattoViewer;

export const getServerSideProps = (async (context) => {
	const slug = context.params?.slug;
	if (!slug || slug.length !== 2) {
		return {
			notFound: true,
		};
	}
	const [servizioId, annuncioId] = slug;
	if (!servizioId || !annuncioId) {
		return {
			notFound: true,
		};
	}

	const parsedServizioId = zServizioId.safeParse(servizioId);
	const parsedAnnuncioId = zAnnuncioId.safeParse(parseInt(annuncioId));

	if (!parsedServizioId.success || !parsedAnnuncioId.success) {
		return {
			notFound: true,
		};
	}

	const access_token = context.req.cookies.access_token;

	const helper = await TrpcAuthedFetchingIstance({ access_token });
	if (helper) {
		await helper.trpc.servizio.getServizioAnnuncio.prefetch({
			annuncioId: parsedAnnuncioId.data,
			servizioId: parsedServizioId.data,
		});

		return {
			props: {
				annuncioId: parsedAnnuncioId.data,
				servizioId: parsedServizioId.data,
				trpcState: helper.trpc.dehydrate(),
			},
		};
	}
	return {
		redirect: {
			destination: "/500",
			permanent: false,
		},
	};
}) satisfies GetServerSideProps<ContrattoViewerProps>;
